I8259_0		EQU	200H
I8259_1		EQU	201H
I8254_0		EQU	210H
I8254_1		EQU	211H
I8254_2		EQU	212H
I8254_CTR	EQU	213H
I8255_A		EQU	220H
I8255_B		EQU	221H
I8255_C		EQU	222H
I8255_CTR	EQU	223H
I0809_CS	EQU	230H

DATA	SEGMENT	PARA
LEDCODE	DB	3FH,06H,5BH,4FH,66H,6DH,7DH,07H,7FH,67H,77H,7CH,39H,5EH,79H,71H
LED1	DB	01H
DATA	ENDS

SSG	SEGMENT STACK
DW	256	DUP(?)
SSG 	ENDS

CODE 	SEGMENT
	ASSUME	CS:CODE, DS:DATA, SS:SSG
START:
	MOV	AX, DATA
	MOV	DS, AX
	NOP	
	MOV	DX, I8255_CTR
	MOV	AL, 10000001B					;设置8255控制字，A口输出、C口低四位输入，高四位输出
	OUT	DX, AL
	MOV	DX, I8254_CTR					;设置8254控制字，CNT0选择方式3
	MOV	AL, 36H
	OUT	DX, AL
	MOV	AX, 120
	MOV	DX, I8254_0						;CNT0输入初始值120用来分频
	OUT	DX, AL
	MOV	AL, AH
	OUT	DX, AL
	MOV	DX, I8254_CTR					;设置8254控制字，CNT1选择方式3
	MOV	AL, 76H
	OUT	DX, AL
	MOV	AX, 260							;CNT1输入初始值260用来控制周期长度
	MOV	DX, I8254_1
	OUT	DX, AL
	MOV	AL, AH
	OUT	DX, AL
	MOV	DX, I8259_0						;设置8259的初始化命令字
	MOV	AL, 00010011B					;ICW1
	OUT	DX, AL
	MOV	DX, I8259_1
	MOV	AL, 00001000B					;ICW2
	OUT	DX, AL
	MOV	AL, 00000001B					;ICW4
	OUT	DX, AL
	
LOP:			
	PUSH	DS
	MOV		AX, 0
	MOV		DS, AX
	LEA		AX, CS:INT_PROC				;获取中断程序的偏移地址
	MOV		SI, 08H						;获得中断类型码
	ADD		SI, SI
	ADD		SI, SI						;中断向量位置=中断类型码×4

	MOV		DS:[SI], AX					;将偏移量写入[SI]起始的两个字节中
	PUSH	CS
	POP		AX
	MOV		DS:[SI+2], AX				;将段地址写入[SI]起始的第三四字节中
	POP		DS							;得到完整中断服务程序入口地址CS:IP
	IN		AL, DX
	AND		AL, 11111110B				;写8059的OCW1，关闭IR0的中断屏蔽
	OUT		DX, AL
	MOV		DX, I0809_CS				;开启AD转换
	OUT		DX, AL
	STI									;开中断
	
INT_PROC:
	PUSH	DX
	PUSH	AX
	MOV	DX, I0809_CS+1
	IN	AL, DX							;获得转换过后的数据
	MOV	CX, 0
	MOV	CH, AL
	MOV	AL, 255
	SUB	AL, CH
	MOV	DX, I8255_A						;输出给8255A口控制LED灯闪烁
	OUT	DX, AL	

	MOV		AL, CH
	AND		AL, 0FFH					;确保脉宽值不为0
	JNZ		LOP3
	INC		AL
LOP3:
	MOV	BL, AL
LOP4:
	MOV	DX, I8255_C
	IN	AL, DX
	AND	AL, 01H
	JNZ	LOP4							;判断OUT1是否为0
	MOV	DX, I8255_CTR
	MOV	AL, 0FH
	OUT	DX, AL							;为0，PC7置1
	MOV	DX, I8254_CTR					;8254CNT2选择方式0
	MOV	AL, 0B0H
	OUT	DX, AL
	MOV	AX, 0
	MOV	AL,BL
	MOV	DX, I8254_2						;脉宽值写入CNT2
	OUT	DX, AL
	MOV	AL, AH
	OUT	DX, AL
LOP1:
	MOV	DX, I8255_C
	IN	AL, DX
	AND	AL, 02H
	JZ	LOP1							;判断OUT2是否为0
	MOV	DX, I8255_CTR
	MOV	AL, 0EH
	OUT	DX, AL							;不为0，置PC7为0
LOP2:
	MOV	DX, I8255_C
	IN	AL, DX
	AND	AL, 01H
	JZ	LOP2							;判断OUT1是否为0
	
	MOV	DX, I8259_0						;不为0，准备关中断
	MOV	AL, 00100000B					;OCW2
	OUT	DX, AL
	MOV	DX, I0809_CS					;关AD转换
	OUT	DX, AL

	POP	AX
	POP	DX
	STI
	IRET
	JMP	LOP

DELAY   PROC						   ;延时子函数
    PUSH 	CX
    PUSH	DX
    MOV  DX, 2
KK1:
    MOV	CX, 8
KK2:LOOP	KK2
	DEC	DX
	JNZ	KK1
	POP	DX
    POP  CX
    RET
DELAY	ENDP 

	CODE	ENDS
END	START
